#
# Try to define a fairly hires clock. Use gettimeofday on systems
# where it is available (sunos anyway).
#
# If it's not there, just bail.
#
# We'll also try the Nexus module's clock routine if it's available.
#
#

eval {
    require Nexus;
};

if ($@ eq '' && defined(&Nexus::wallclock()))
{
#    print "Using nexus clock\n";
    eval ' sub wallclock { return Nexus::wallclock(); } ';
}
else
{
    eval {
	require 'syscall.ph';
    };
    if ($@ eq '' && defined(&SYS_gettimeofday))
    {
#	print "Using gettimeofday\n";
	eval ' sub wallclock
	   {
	       my($timebuf) = \' \' x 8;
	       my($sec, $us);
	       syscall(&SYS_gettimeofday, $timebuf, 0);
	       ($sec, $us) = unpack("LL", $timebuf);
	       return $sec + $us / 1000000.0;
	   }
       ';
    }
    else
    {
#	print "Using time\n";
	eval ' sub wallclock { return time; } ';
    }
}

1;
